/* dinniz.c - Rad sa dinamickim nizovima */

#include <stdio.h>
#include <stdlib.h>

typedef struct { int *a, n; } Din_niz;

Din_niz sastavi_din_niz (int a[], int n) {
  Din_niz dn; int i;
  dn.a = malloc(n*sizeof(int)); if (dn.a == 0) exit (1);
  dn.n = n;
  for (i=0; i<n; i++) dn.a[i] = a[i];
  return dn;
}

void    razlozi_din_niz (Din_niz dn, int a[], int *n) {
  int i;
  for (i=0; i<dn.n; i++) a[i] = dn.a[i];
  *n = dn.n;
}

Din_niz kopiraj_din_niz (Din_niz dn) {
  Din_niz dn2; int i;
  dn2.a = malloc(dn.n*sizeof(int)); if (dn2.a == 0) exit (1);
  dn2.n = dn.n;
  for (i=0; i<dn.n; i++) dn2.a[i] = dn.a[i];
  return dn2;
}

void    obrni_din_niz   (Din_niz dn) {
  int i, j, b;
  for (i=0, j=dn.n-1; i<j; i++, j--)
    { b = dn.a[i]; dn.a[i] = dn.a[j]; dn.a[j] = b; }
}

Din_niz citaj_din_niz   () {
  Din_niz dn; int i;
  printf ("Duzina niza? "); scanf ("%d", &dn.n);
  if (dn.n >= 0) {
    dn.a = malloc(dn.n*sizeof(int)); if (dn.a == 0) exit (1);
    printf ("Elementi niza? ");
    for (i=0; i<dn.n; scanf ("%d", &dn.a[i++]));
  } else dn.a = 0;
  return dn;
}

void    pisi_din_niz    (Din_niz dn) {
  int i;
  for (i=0; i<dn.n; i++) {
    printf ("%6d", dn.a[i]);
    if (i%10 == 9 || i == dn.n-1) putchar ('\n');
  }
}

main () {
  Din_niz dn1, dn2, dn3; int a[50], n, i;
  while (1) {
    dn1 = citaj_din_niz ();
  if (dn1.a == 0) break;
    printf ("Procitani niz:   "); pisi_din_niz (dn1);
    dn2 = kopiraj_din_niz (dn1);
    printf ("Kopirani niz:    "); pisi_din_niz (dn2);
    obrni_din_niz (dn2);
    printf ("Obrnuti niz:     "); pisi_din_niz (dn2);
    razlozi_din_niz (dn1, a, &n);
    printf ("Razlozeni niz:   ");
    for (i=0; i<n; printf ("%6d", a[i++])); putchar ('\n');
    dn3 = sastavi_din_niz (a, n);
    printf ("Sastavljeni niz: "); pisi_din_niz (dn3);
    free (dn1.a); free (dn2.a); free (dn3.a);
    putchar ('\n');
  }
}
