/* matrice.c - Rad sa matricama */

#include <stdio.h>
#define N 50

typedef float Matr[N][N];

/* r(m,n) = p(m,n) + q(m,n) */
void zbir (Matr p, Matr q, Matr r, int m, int n) {
  int i, j;
  for (i=0; i<m; i++)
    for (j=0; j<n; j++)
      r[i][j] = p[i][j] + q[i][j];
}

/* r(m,n) = p(m,n) - q(m,n) */
void razlika (Matr p, Matr q, Matr r, int m, int n) {
  int i, j;
  for (i=0; i<m; i++)
    for (j=0; j<n; j++)
      r[i][j] = p[i][j] - q[i][j];
}

/* r(l,n) = p(l,m) * q(m,n) */
void proizvod (Matr p, Matr q, Matr r, int l, int m, int n) {
  int i, j, k;
  for (i=0; i<l; i++)
    for (k=0; k<n; k++) {
      r[i][k] = 0;
      for (j=0; j<m; j++)
        r[i][k] += p[i][j] * q[j][k];
    }
}

int citaj (FILE *dat, Matr p, int *m, int *n) {
  int i, j;
  fscanf (dat, "%d%d", m, n);
  if (*m<=0 || *m>N || *n<=0 || *n>N) return 0;
  for (i=0; i<*m; i++)
    for (j=0; j<*n; fscanf(dat, "%f", &p[i][j++]));
  return 1;
}

void pisi (FILE *dat, char *naslov, char *frm, Matr p, int m, int n) {
  int i, j;
  fprintf (dat, "\n%s\n\n", naslov);
  for (i=0; i<m; i++) {
    for (j=0; j<n; j++) {
      fprintf (dat, frm, p[i][j]);
      if (j%10==9 || j==n-1) fputc ('\n', dat);
    }
    if (n > 10) fputc ('\n', dat);
  }
}

main () {
  Matr a, b, c; int l, m, n;
  char ulaz[20], izlaz[20];
  FILE *ul, *izl;
  printf ("Ime ulazne datoteke?  "); scanf ("%s", ulaz);
  printf ("Ime izlazne datoteke? "); scanf ("%s", izlaz);
  ul  = fopen (ulaz, "r");
  izl = fopen (izlaz, "w");
  citaj (ul, a, &l, &m);       pisi (izl, "Prva matrica",     "%6.1f", a, l, m);
  citaj (ul, b, &m, &n);       pisi (izl, "Druga matrica",    "%6.1f", b, m, n);
  proizvod (a, b, c, l, m, n); pisi (izl, "Proizvod matrica", "%6.1f", c, l, n);
  while (citaj(ul,a,&m,&n) && citaj(ul,b,&m,&n)) {
    pisi (izl, "Prva matrica",    "%6.1f", a, m, n);
    pisi (izl, "Druga matrica",   "%6.1f", b, m, n);
    zbir    (a, b, c, m, n);   pisi (izl, "Zbir matrica",    "%6.1f", c, m, n);
    razlika (a, b, c, m, n);   pisi (izl, "Razlika matrica", "%6.1f", c, m, n);
  }
  fclose (ul); fclose (izl);
}
